unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  IdFTP, IdComponent, IdFTPCommon;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnDownload: TButton;
    btnConnect: TButton;
    btnDisconnect: TButton;
    eHost: TEdit;
    eUser: TEdit;
    ePassword: TEdit;
    eDir: TEdit;
    eFile: TEdit;
    ftp: TIdFTP;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnDownloadClick(Sender: TObject);
    procedure ftpConnected(Sender: TObject);
    procedure ftpDisconnected(Sender: TObject);
    procedure ftpWork(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCount: Int64);
    procedure ftpWorkBegin(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCountMax: Int64);
    procedure ftpWorkEnd(ASender: TObject; AWorkMode: TWorkMode);
  private

  public
    STime: TDateTime;
    FFileSize: Int64;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnDownloadClick(Sender: TObject);
begin
  FFileSize := ftp.Size(eFile.Text);
  ftp.Get(eFile.Text, eFile.Text, true, false);
end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  ftp.Host:=eHost.Text;
  ftp.TransferType:=ftBinary;
  ftp.Username:=eUser.Text;
  ftp.Password:=ePassword.Text;
  ftp.Connect;

  if eDir.Text <> '' then
  begin
    ftp.ChangeDir(eDir.Text);
  end;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
  ftp.Disconnect;
end;

procedure TForm1.ftpConnected(Sender: TObject);
begin
  btnConnect.Enabled := false;
  btnDisconnect.Enabled := true;
  btnDownload.Enabled := true;
  StatusBar1.Panels[0].Text := 'Connected';
end;

procedure TForm1.ftpDisconnected(Sender: TObject);
begin
  btnConnect.Enabled := true;
  btnDisconnect.Enabled := false;
  btnDownload.Enabled := false;
  StatusBar1.Panels[0].Text := 'Disconnected';
end;

procedure TForm1.ftpWork(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCount: Int64);
var
  S: String;
  TotalTime: TDateTime;
  H, M, Sec, MS: Word;
  DLTime: Double;
  AverageSpeed: Double;
begin
  TotalTime := Now - STime;
  DecodeTime(TotalTime, H, M, Sec, MS);
  Sec := Sec + M * 60 + H * 3600;
  DLTime := Sec + MS / 1000;
  if DLTime > 0 then
    AverageSpeed := (AWorkCount / 1024) / DLTime;
  S := FormatFloat('0.00 KB/s', AverageSpeed);
  case AWorkMode of
    wmRead: StatusBar1.Panels[1].Text:= 'D: ' + S;
    wmWrite: StatusBar1.Panels[1].Text:= 'U: ' + S;
  end;

  //
  StatusBar1.Panels[2].Text:= TimeToStr(TotalTime);

  ProgressBar1.Position := AWorkCount;
  Application.ProcessMessages;

end;

procedure TForm1.ftpWorkBegin(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCountMax: Int64);
begin
  if AWorkCountMax <> 0 then
    Progressbar1.Max := AWorkCountMax
  else
    Progressbar1.Max := FFileSize;

  Progressbar1.Position := 0;
  STime := Now;
end;

procedure TForm1.ftpWorkEnd(ASender: TObject; AWorkMode: TWorkMode);
begin
  Progressbar1.Position:=0;
end;

end.

